SystemOrganization addCategory: #'Gradualtalk-Compiler'!

Trait named: #TTyped
	uses: {}
	category: 'Gradualtalk-Compiler'!

!TTyped classSide methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 21:17'!
compilerContext
	^OTCSupport defaultCompilerContext! !

!Class methodsFor: '*Gradualtalk-Compiler' stamp: 'EstebanAllende 3/27/2013 16:07'!
subclass: t instanceVariableNames: f classVariableNames: d poolDictionaries: s category: cat 
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class (the receiver)."
	|class varParser|
	varParser :=( (GTVariablesParser new)
		class: t;
		ivar: f;
		cvar: d).

	class := (ClassBuilder new)
		superclass: self
		subclass: t
		instanceVariableNames: varParser oldIvar
		classVariableNames: varParser oldCvar
		poolDictionaries: s
		category: cat.
	
	"Here we must check if all old instances comply with the type specification"
	varParser annotateVars.
	^class! !

Object subclass: #CastExpr
	instanceVariableNames: 'castType implicit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Compiler'!

!CastExpr class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/5/2011 16:58'!
addCast: aCast to: aNode

	|castCollection|
	castCollection := aNode propertyAt: #cast ifAbsentPut: [OrderedCollection new].
	aCast implicit 
		ifTrue: [	castCollection addFirst: aCast.] 
		ifFalse: [castCollection addLast: aCast.].! !

!CastExpr class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/5/2011 16:58'!
explicitToType: aType

	^self new castType: aType; implicit: false; yourself.! !

!CastExpr class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/5/2011 16:59'!
toType: aType
	^self new castType: aType; implicit: true; yourself.! !

!CastExpr methodsFor: 'accessing' stamp: 'EstebanAllende 12/5/2011 16:57'!
castType

	^ castType! !

!CastExpr methodsFor: 'accessing' stamp: 'EstebanAllende 12/5/2011 16:57'!
castType: anObject

	castType := anObject! !

!CastExpr methodsFor: 'accessing' stamp: 'EstebanAllende 12/5/2011 16:57'!
implicit

	^ implicit! !

!CastExpr methodsFor: 'accessing' stamp: 'EstebanAllende 12/5/2011 16:57'!
implicit: anObject

	implicit := anObject! !

Object subclass: #GTCast
	instanceVariableNames: 'castType implicit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Compiler'!

!GTCast class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 3/30/2013 12:54'!
to: aType
	^self new 
		castType: aType; 
		yourself.! !

!GTCast methodsFor: 'accessing' stamp: 'EstebanAllende 3/30/2013 12:50'!
castType

	^ castType! !

!GTCast methodsFor: 'accessing' stamp: 'EstebanAllende 3/30/2013 12:50'!
castType: anObject

	castType := anObject! !

!GTCast methodsFor: 'accessing' stamp: 'EstebanAllende 3/30/2013 12:50'!
implicit

	^ implicit! !

!GTCast methodsFor: 'accessing' stamp: 'EstebanAllende 3/30/2013 12:50'!
implicit: anObject

	implicit := anObject! !

!GTCast methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 3/30/2013 12:54'!
initialize
	implicit := true.! !

!GTCast methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 3/30/2013 12:54'!
makeExplicit
	implicit := false.! !

Object subclass: #OTCSupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Compiler'!

OTCSupport class
	instanceVariableNames: 'bootstrapping'!

OTCSupport class
	instanceVariableNames: 'bootstrapping'!

!OTCSupport class methodsFor: 'accessing' stamp: 'EstebanAllende 3/20/2013 16:49'!
defaultCompilerContext
	^OCCompilerContext new
		parserBlock: self defaultParser;
		astAnalyzerBlock: OCCompilerContext defaultASTAnalyzer;
		irBuilderBlock: OCCompilerContext defaultIRBuilder;
		bytecodeGeneratorBlock: OCCompilerContext defaultBytecodeGenerator;
		mapperBlock: OCCompilerContext defaultMapper;
		yourself.
! !

!OTCSupport class methodsFor: 'accessing' stamp: 'EstebanAllende 1/24/2013 18:15'!
defaultParser

	^[:request | (GradualtalkParser new) 
							parse: request sourceStream contents
	 						onError: [ :msg :pos | self error: msg ]].! !

!RBProgramNode methodsFor: '*Gradualtalk-Compiler' stamp: 'EstebanAllende 3/30/2013 13:19'!
addAsFirstCast: aTypeOrTypeNode
	|castCollection cast|
	castCollection := self propertyAt: #gtCast ifAbsentPut: [OrderedCollection new].
	cast := GTCast to: aTypeOrTypeNode.
	castCollection addFirst: cast.
	^cast
	! !

!RBProgramNode methodsFor: '*Gradualtalk-Compiler' stamp: 'EstebanAllende 3/30/2013 13:19'!
addAsLastCast: aTypeOrTypeNode
	|castCollection cast|
	castCollection := self propertyAt: #gtCast ifAbsentPut: [OrderedCollection new].
	cast := GTCast to: aTypeOrTypeNode.
	castCollection addLast: cast.
	^cast! !
